<template>
  <section class="login">
    <h3 class="text-center display-4">Entrar</h3>
    <hr>
    <form action="">
      <input
        type="email"
        placeholder="email"
        v-model="email"
        class="form-control">
      <input
        type="password"
        placeholder="senha"
        v-model="password"
        class="form-control">
    </form>
    <div>
      <p v-if="loginError">Algo deu errado, por favor tente novamente mais tarde...</p>
      <p v-else>&nbsp;</p>
    </div>
    <button
      type="submit"
      @click.prevent="submit"
      :class="btnClass"
      :disabled="submitting">
      Entrar
    </button>
    <hr>
    <small class="form-text text-muted">Sem cadastro? <nuxt-link to="/cadastro">Crie uma conta</nuxt-link></small>
  </section>
</template>

<script>
export default {
  data() {
    return {
      loginError: false,
      btnClass: ["btn", "btn-submit", "btn-touch"],
      submitting: false
    };
  },
  computed: {
    email: {
      get() {
        return this.$store.getters.loginInfo.email;
      },
      set(value) {
        this.$store.commit('setLoginEmail', value);
      }
    },
    password: {
      get() {
        return this.$store.getters.loginInfo.password;
      },
      set(value) {
        this.$store.commit('setLoginPassword', value);
      }
    }
  },
  methods: {
    submit() {
      this.submitting = true;
      this.btnClass = this.btnClass.concat("btn-disabled");
      let ins = this;
      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/login',
        data: ins.$store.getters.loginInfo
      })
        .then( res => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.loginError = false;

          // set infos for logged user
          ins.$store.commit('setToken', res.data.auth_token);
          ins.$store.commit('setUserEmail', ins.$store.getters.loginInfo.email);

          // clear login data
          ins.$store.commit('clearLoginInfo');

          // redirect
          ins.$router.push('/');
        })
        .catch( err => {
          ins.submitting = false;
          ins.btnClass.pop();
          ins.loginError = true;
        });
    }
  }
}
</script>

<style>
.login input {
  margin: 1vh 0px;
}
</style>
